/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            FCylinder.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef FCYLINDER_H
#define FCYLINDER_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace X3D {

class FCylinder : public Cylinder
{
public:
  // Constructor.
  FCylinder();
  // Constructs a Cylinder from its attributes.
  FCylinder(SFBool bottom, 
            SFFloat radius, 
            SFFloat height, 
            SFBool side, 
            SFBool top,
            SFInt32 section);
            
  // Clones the node.
  virtual SFNode clone() const;  
  // sets the number of sections.
  void setSection(SFInt32 section);

  // gets the number of sections.
  inline SFInt32 getSection() const {return _section;};
  
  // Loads the attributes from a X3DFileElement e.
  virtual void load(const X3DFileElement *element);
  // Writes the attributes of the node.
  virtual SFString write() const;

protected:
  // Copy constructor.	   
  FCylinder(const FCylinder &C);

private:
  SFInt32 _section;
};

}
}

#endif
