/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            GLSimpleAnimatorGlobalVariables.h               //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLSIMPLEANIMATORGLOBALVARIABLES_H
#define GLSIMPLEANIMATORGLOBALVARIABLES_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace GL {

/// GlobalVariables for the SimpleAnimator module.

class SimpleAnimatorGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  SimpleAnimatorGlobalVariables();
  /// Destructor.
  virtual ~SimpleAnimatorGlobalVariables();

  /// Sets the bboxSize.
  void setBboxSize(const SFVec3f &size);
  /// Sets the time.
  void setTime(float time);

  /// Gets the time.
  float getTime() const {return _time;};
  /// Sets the bboxSize.
  inline SFVec3f getBboxSize() const {return _bboxSize;};
  
private: 
  float _time;
  SFVec3f _bboxSize;
};

}
}

#endif
