////////////////////////////////////////////////////////////////////////////////
//  generated by script                                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DKERNEL_H
#define X3DKERNEL_H

//Component
#include "private/AbstractCreator.h"
#include "private/AbstractVisitor.h"
#include "private/AbstractWalker.h"
#include "private/CoreCreator.h"
#include "private/CoreVisitor.h"
#include "private/CoreWalker.h"
#include "private/DefaultCoreCreator.h"
#include "private/DefaultGeometry3DCreator.h"
#include "private/DefaultGroupingCreator.h"
#include "private/DefaultInterpolationCreator.h"
#include "private/DefaultLightingCreator.h"
#include "private/DefaultNURBSCreator.h"
#include "private/DefaultNodeCreationProxy.h"
#include "private/DefaultRenderingCreator.h"
#include "private/DefaultShapeCreator.h"
#include "private/DefaultTexturingCreator.h"
#include "private/Geometry3DCreator.h"
#include "private/Geometry3DVisitor.h"
#include "private/Geometry3DWalker.h"
#include "private/GroupingCreator.h"
#include "private/GroupingVisitor.h"
#include "private/GroupingWalker.h"
#include "private/InterpolationCreator.h"
#include "private/InterpolationVisitor.h"
#include "private/InterpolationWalker.h"
#include "private/LightingCreator.h"
#include "private/LightingVisitor.h"
#include "private/LightingWalker.h"
#include "private/NURBSCreator.h"
#include "private/NURBSVisitor.h"
#include "private/NURBSWalker.h"
#include "private/RenderingCreator.h"
#include "private/RenderingVisitor.h"
#include "private/RenderingWalker.h"
#include "private/ShapeCreator.h"
#include "private/ShapeVisitor.h"
#include "private/ShapeWalker.h"
#include "private/TexturingCreator.h"
#include "private/TexturingVisitor.h"
#include "private/TexturingWalker.h"

//FileValidator
#include "private/FileValidator.h"
#include "private/FileValidatorGeometry3DVisitor.h"
#include "private/FileValidatorGlobalVariables.h"

//GLComponent
#include "private/GLCoreVisitor.h"
#include "private/GLCoreWalker.h"
#include "private/GLGeometry3DVisitor.h"
#include "private/GLGeometry3DWalker.h"
#include "private/GLGroupingVisitor.h"
#include "private/GLGroupingWalker.h"
#include "private/GLRenderingVisitor.h"
#include "private/GLRenderingWalker.h"
#include "private/GLShapeVisitor.h"
#include "private/GLShapeWalker.h"
#include "private/GLTexturingVisitor.h"
#include "private/GLTexturingWalker.h"

//Image
#include "private/Image.h"
#include "private/JPGImageType.h"
#include "private/X3DImageType.h"

//Loader
#include "private/DefaultLoader.h"
#include "private/QLoader.h"
#include "private/X3DLoader.h"
#include "private/XercesLoader.h"

//MemReleaser
#include "private/MemReleaser.h"
#include "private/MemReleaserAbstractVisitor.h"
#include "private/MemReleaserGlobalVariables.h"

//NodeProxy
#include "private/CreationFunction.h"
#include "private/EnterFunction.h"
#include "private/LeaveFunction.h"
#include "private/NodeCreationProxy.h"
#include "private/NodeVisitingProxy.h"
#include "private/NodeWalkingProxy.h"

//Type
#include "private/Component.h"
#include "private/Type.h"
#include "private/VisitingFunctions.h"
#include "private/WalkOnFunction.h"
#include "private/WalkingFunction.h"

//X3DAbstractNode
#include "private/NameDict.h"
#include "private/X3DAbstractNode.h"
#include "private/X3DActiveFunction.h"

//X3DComponent
#include "private/X3DComponent.h"
#include "private/X3DComponentCreator.h"
#include "private/X3DComponentVisitor.h"
#include "private/X3DComponentWalker.h"
#include "private/X3DFunction.h"
#include "private/X3DNodeProxy.h"

//TTAlgorithm
#include "private/DFS.h"
#include "private/DFSCoreWalker.h"
#include "private/DFSGeometry3DWalker.h"
#include "private/DFSGroupingWalker.h"
#include "private/DFSInterpolationWalker.h"
#include "private/DFSLightingWalker.h"
#include "private/DFSNURBSWalker.h"
#include "private/DFSRenderingWalker.h"
#include "private/DFSShapeWalker.h"
#include "private/DFSTexturingWalker.h"
#include "private/DefaultDFS.h"
#include "private/DefaultDFSCoreWalker.h"
#include "private/DefaultDFSGeometry3DWalker.h"
#include "private/DefaultDFSGroupingWalker.h"
#include "private/DefaultDFSInterpolationWalker.h"
#include "private/DefaultDFSLightingWalker.h"
#include "private/DefaultDFSNURBSWalker.h"
#include "private/DefaultDFSRenderingWalker.h"
#include "private/DefaultDFSShapeWalker.h"
#include "private/DefaultDFSTexturingWalker.h"

//DefaultX3DProcessors
#include "private/X3DBboxUpdater.h"
#include "private/X3DFileValidator.h"
#include "private/X3DGLBuilder.h"
#include "private/X3DGLRenderer.h"
#include "private/X3DGLUpdater.h"
#include "private/X3DMemReleaser.h"
#include "private/X3DSceneSaver.h"
#include "private/GLDFS.h"
#include "private/GLDFSCoreWalker.h"
#include "private/GLDFSGeometry3DWalker.h"
#include "private/GLDFSGroupingWalker.h"
#include "private/GLDFSRenderingWalker.h"
#include "private/GLDFSShapeWalker.h"
#include "private/GLDFSTexturingWalker.h"
#include "private/GLDefaultDFS.h"
#include "private/GLDefaultDFSCoreWalker.h"
#include "private/GLDefaultDFSGeometry3DWalker.h"
#include "private/GLDefaultDFSGroupingWalker.h"
#include "private/GLDefaultDFSRenderingWalker.h"
#include "private/GLDefaultDFSShapeWalker.h"
#include "private/GLDefaultDFSTexturingWalker.h"
#include "private/GVManager.h"
#include "private/GlobalVariables.h"
#include "private/X3DOnePassProcessor.h"
#include "private/X3DProcessor.h"
#include "private/X3DTTAlgorithm.h"

//X3DGLNodes

//GLCore
#include "private/GLScene.h"
#include "private/X3DGLNode.h"

//GLGeometry3D
#include "private/BoxDrawArray.h"
#include "private/ConeDrawArray.h"
#include "private/CylinderDrawArray.h"
#include "private/GLBox.h"
#include "private/GLCone.h"
#include "private/GLCylinder.h"
#include "private/GLIndexedFaceSet.h"
#include "private/GLSphere.h"
#include "private/SphereDrawArray.h"

//GLGrouping
#include "private/GLGroup.h"
#include "private/GLStaticGroup.h"
#include "private/GLTransform.h"
#include "private/X3DGLChildNode.h"
#include "private/X3DGLGroupingNode.h"

//GLRendering
#include "private/GLIndexedLineSet.h"
#include "private/GLPointSet.h"
#include "private/GLTriangleFanSet.h"
#include "private/GLTriangleSet.h"
#include "private/GLTriangleStripSet.h"
#include "private/X3DGLComposedGeometryNode.h"
#include "private/X3DGLGeometry3DNode.h"
#include "private/X3DGLGeometryNode.h"

//GLShape
#include "private/GLAppearance.h"
#include "private/GLFillProperties.h"
#include "private/GLLineProperties.h"
#include "private/GLMaterial.h"
#include "private/GLShape.h"
#include "private/X3DGLAppearanceChildNode.h"
#include "private/X3DGLAppearanceNode.h"
#include "private/X3DGLMaterialNode.h"
#include "private/X3DGLShapeNode.h"

//GLTexturing
#include "private/GLImageTexture.h"
#include "private/X3DGLTexture2DNode.h"
#include "private/X3DGLTextureNode.h"
#include "private/X3DGLTextureTransformNode.h"

//X3DNodes

//Core
#include "private/Scene.h"
#include "private/X3DNode.h"
#include "private/X3DObject.h"

//FileElement
#include "private/QFileElement.h"
#include "private/X3DFileElement.h"
#include "private/XercesFileElement.h"

//Geometry3D
#include "private/Box.h"
#include "private/Cone.h"
#include "private/Cylinder.h"
#include "private/IndexedFaceSet.h"
#include "private/Sphere.h"

//Grouping
#include "private/Group.h"
#include "private/StaticGroup.h"
#include "private/Transform.h"
#include "private/X3DBoundedObject.h"
#include "private/X3DChildNode.h"
#include "private/X3DGroupingNode.h"

//Interpolation
#include "private/ColorInterpolator.h"
#include "private/CoordinateInterpolator.h"
#include "private/CoordinateInterpolator2D.h"
#include "private/NormalInterpolator.h"
#include "private/OrientationInterpolator.h"
#include "private/PositionInterpolator.h"
#include "private/PositionInterpolator2D.h"
#include "private/ScalarInterpolator.h"
#include "private/X3DInterpolatorNode.h"

//Lighting
#include "private/DirectionalLight.h"
#include "private/PointLight.h"
#include "private/SpotLight.h"
#include "private/X3DLightNode.h"

//NURBS
#include "private/Contour2D.h"
#include "private/ContourPolyline2D.h"
#include "private/CoordinateDeformer.h"
#include "private/NurbsCurve.h"
#include "private/NurbsCurve2D.h"
#include "private/NurbsGroup.h"
#include "private/NurbsPositionInterpolator.h"
#include "private/NurbsSurface.h"
#include "private/NurbsTextureSurface.h"
#include "private/TrimmedSurface.h"
#include "private/X3DParametricGeometryNode.h"

//Rendering
#include "private/Color.h"
#include "private/ColorRGBA.h"
#include "private/Coordinate.h"
#include "private/IndexedLineSet.h"
#include "private/Normal.h"
#include "private/PointSet.h"
#include "private/TriangleFanSet.h"
#include "private/TriangleSet.h"
#include "private/TriangleStripSet.h"
#include "private/X3DColorNode.h"
#include "private/X3DComposedGeometryNode.h"
#include "private/X3DCoordinateNode.h"
#include "private/X3DGeometricPropertyNode.h"
#include "private/X3DGeometry3DNode.h"
#include "private/X3DGeometryNode.h"
#include "private/X3DNormalNode.h"

//Shape
#include "private/Appearance.h"
#include "private/FillProperties.h"
#include "private/LineProperties.h"
#include "private/Material.h"
#include "private/Shape.h"
#include "private/X3DAppearanceChildNode.h"
#include "private/X3DAppearanceNode.h"
#include "private/X3DMaterialNode.h"
#include "private/X3DShapeNode.h"

//Texturing
#include "private/ImageTexture.h"
#include "private/TextureCoordinate.h"
#include "private/X3DTexture2DNode.h"
#include "private/X3DTextureCoordinateNode.h"
#include "private/X3DTextureNode.h"
#include "private/X3DTextureTransformNode.h"

//X3DTypes
#include "private/Bbox.h"
#include "private/SFMatrix34f.h"
#include "private/SFPoint3f.h"
#include "private/SFString.h"
#include "private/SFVec3f.h"
#include "private/X3DBaseTypes.h"
#include "private/X3DGLTypes.h"
#include "private/X3DTypes.h"
#include "private/X3DTypesToSFString.h"

#endif
