/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            DefaultNURBSCreator.h                           //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTNURBSCREATOR_H
#define DEFAULTNURBSCREATOR_H

#include "NURBSCreator.h"

namespace X3DTK {
namespace X3D {

/// Concrete component Creator for the NURBS component defining the default 
/// X3D nodes.

class DefaultNURBSCreator : public NURBSCreator
{
public:
  /// Constructor.
  DefaultNURBSCreator();
  /// Destructor.
  virtual ~DefaultNURBSCreator();
  
  /// Creates a Contour2D.
  SFNode createContour2D() const;
  /// Creates a ContourPolyline2D.
  SFNode createContourPolyline2D() const;
  /// Creates a NurbsCurve.
  SFNode createNurbsCurve() const;
  /// Creates a NurbsCurve2D.
  SFNode createNurbsCurve2D() const;
  /// Creates a NurbsGroup.
  SFNode createNurbsGroup() const;
  /// Creates a NurbsPositionInterpolator.
  SFNode createNurbsPositionInterpolator() const;
  /// Creates a NurbsSurface.
  SFNode createNurbsSurface() const;
  /// Creates a NurbsTextureSurface.
  SFNode createNurbsTextureSurface() const;
  /// Creates a TrimmedSurface.
  SFNode createTrimmedSurface() const;
};

}
}

#endif
