/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            SceneSaver.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef SCENESAVER_H
#define SCENESAVER_H

#include "X3DSceneSaver.h"
#include "SceneSaverGlobalVariables.h"
#include "DFS.h"

namespace X3DTK {
namespace X3D {

class Scene;

/// SceneSaver module.

class SceneSaver : public X3DSceneSaver
{
public:
  /// Constructor.
  SceneSaver(DFS *dfs = 0);
  /// Destructor.
  virtual ~SceneSaver();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Writes the content of S in file.
  virtual void saveAs(Scene *S, const SFString &fileName) const;
  /// Writes the content of S in file.
  virtual void save(Scene *S) const;

  void *getDFS() {return (void *)dfs;};

protected:
  SceneSaverGlobalVariables *globalVariables;
  bool defaultDFSUSE;
  DFS *dfs;
};

}
}

#endif
