#include "DefaultShapeCreator.h"
#include "Appearance.h"
#include "FillProperties.h"
#include "LineProperties.h"
#include "Material.h"
#include "Shape.h"

namespace X3DTK {
namespace X3D {

DefaultShapeCreator::DefaultShapeCreator()
{
  defineNewCreationFunction<DefaultShapeCreator>("Appearance" , &DefaultShapeCreator::createAppearance);
  defineNewCreationFunction<DefaultShapeCreator>("FillProperties" , &DefaultShapeCreator::createFillProperties);
  defineNewCreationFunction<DefaultShapeCreator>("LineProperties" , &DefaultShapeCreator::createLineProperties);
  defineNewCreationFunction<DefaultShapeCreator>("Material" , &DefaultShapeCreator::createMaterial);
  defineNewCreationFunction<DefaultShapeCreator>("Shape" , &DefaultShapeCreator::createShape);
  defineNewCreationFunction<DefaultShapeCreator>("X3DAppearanceChildNode" , 0);
  defineNewCreationFunction<DefaultShapeCreator>("X3DAppearanceNode" , 0);
  defineNewCreationFunction<DefaultShapeCreator>("X3DMaterialNode" , 0);
  defineNewCreationFunction<DefaultShapeCreator>("X3DShapeNode" , 0);
}

DefaultShapeCreator::~DefaultShapeCreator()
{
}

SFNode DefaultShapeCreator::createAppearance() const
{
  return new Appearance();
}

SFNode DefaultShapeCreator::createFillProperties() const
{
  return new FillProperties();
}

SFNode DefaultShapeCreator::createLineProperties() const
{
  return new LineProperties();
}

SFNode DefaultShapeCreator::createMaterial() const
{
  return new Material();
}

SFNode DefaultShapeCreator::createShape() const
{
  return new Shape();
}

}
}
