#include "DefaultTexturingCreator.h"
#include "ImageTexture.h"
#include "TextureCoordinate.h"

namespace X3DTK {
namespace X3D {

DefaultTexturingCreator::DefaultTexturingCreator()
{
  defineNewCreationFunction<DefaultTexturingCreator>("ImageTexture" , &DefaultTexturingCreator::createImageTexture);
  defineNewCreationFunction<DefaultTexturingCreator>("TextureCoordinate" , &DefaultTexturingCreator::createTextureCoordinate);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTexture2DNode" , 0);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTextureCoordinateNode" , 0);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTextureNode" , 0);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTextureTransformNode" , 0);
}

DefaultTexturingCreator::~DefaultTexturingCreator()
{
}

SFNode DefaultTexturingCreator::createImageTexture() const
{
  return new ImageTexture();
}

SFNode DefaultTexturingCreator::createTextureCoordinate() const
{
  return new TextureCoordinate();
}

}
}
