#include "FileValidator.h"
#include "DefaultDFS.h"
#include "FileValidatorGeometry3DVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

FileValidator::FileValidator()
: X3DFileValidator()
{
  globalVariables = GVManager::getInstanceOf<FileValidatorGlobalVariables>();
  
  dfs = new DefaultDFS();
  dfs->setComponentVisitor(new FileValidatorGeometry3DVisitor());
}

FileValidator::~FileValidator()
{
  delete dfs;
}

void FileValidator::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
}

bool FileValidator::validate(SFNode N) const
{
  globalVariables->setValidity(true);
  dfs->traverse(N);
  return globalVariables->getValidity();
}

}
}
