#include "Image.h"
#include "JPGImageType.h"
#include "SFString.h"

#include <iostream>

using namespace std;

namespace X3DTK {

Image::Image()
: _imageType(0)
{
}

Image::Image(const char *fileName)
{
  load(fileName);
}

Image::~Image()
{
  delete _imageType;
}
  
bool Image::load(const char *fileName)
{
  SFString file(fileName);
  
  if (file.getExtension() == "jpg")
  {
    _imageType = new JPGImageType();
    return _imageType->load(fileName);
  }
  
  cerr << "sorry, " << file.getExtension() << " format not yet supported!" << endl;
  return false;
}

void Image::resize(unsigned short width, unsigned short height)
{
  if (_imageType != 0)
    _imageType->resize(width, height);
}

void Image::resizeGL(float (& textureTransform)[16])
{
  if (_imageType != 0)
    _imageType->resizeGL(textureTransform);
}

}
