#include "DefaultDFS.h"
#include "DefaultDFSCoreWalker.h"
#include "DefaultDFSGeometry3DWalker.h"
#include "DefaultDFSGroupingWalker.h"
#include "DefaultDFSRenderingWalker.h"
#include "DefaultDFSShapeWalker.h"
#include "DefaultDFSTexturingWalker.h"
#include "DefaultDFSInterpolationWalker.h"
#include "DefaultDFSLightingWalker.h"
#include "DefaultDFSNURBSWalker.h"

namespace X3DTK {
namespace X3D {

DefaultDFS::DefaultDFS()
{
  setComponentWalker(new DefaultDFSCoreWalker());
  setComponentWalker(new DefaultDFSGeometry3DWalker());
  setComponentWalker(new DefaultDFSGroupingWalker());
  setComponentWalker(new DefaultDFSRenderingWalker());
  setComponentWalker(new DefaultDFSShapeWalker());
  setComponentWalker(new DefaultDFSTexturingWalker());
  setComponentWalker(new DefaultDFSInterpolationWalker());
  setComponentWalker(new DefaultDFSLightingWalker());
  setComponentWalker(new DefaultDFSNURBSWalker());
}

DefaultDFS::~DefaultDFS()
{
}

void DefaultDFS::setComponentWalker(X3DComponentWalker *component)
{
  DFS::setComponentWalker(component);
}

}
}
