#include "GLDefaultDFSRenderingWalker.h"
#include "NodeWalkingProxy.h"
#include "NodeVisitingProxy.h"
#include "X3DGLComposedGeometryNode.h"
#include "GLIndexedLineSet.h"
#include "GLPointSet.h"

namespace X3DTK {
namespace GL {

DefaultDFSRenderingWalker::DefaultDFSRenderingWalker()
: DFSRenderingWalker()
{
  defineNewWalkingFunction<DefaultDFSRenderingWalker, X3DComposedGeometryNode>(&DefaultDFSRenderingWalker::walkX3DComposedGeometryNode);
  defineNewWalkingFunction<DefaultDFSRenderingWalker, IndexedLineSet>(&DefaultDFSRenderingWalker::walkIndexedLineSet);
  defineNewWalkingFunction<DefaultDFSRenderingWalker, PointSet>(&DefaultDFSRenderingWalker::walkPointSet);
}

DefaultDFSRenderingWalker::~DefaultDFSRenderingWalker()
{
}

void DefaultDFSRenderingWalker::walkX3DComposedGeometryNode(X3DComposedGeometryNode *N) const
{
  nodeVisitingProxy->enter(N);
  nodeVisitingProxy->leave(N);
}

void DefaultDFSRenderingWalker::walkIndexedLineSet(IndexedLineSet *I) const
{
  nodeVisitingProxy->enter(I);
  nodeVisitingProxy->leave(I);
}

void DefaultDFSRenderingWalker::walkPointSet(PointSet *P) const
{
  nodeVisitingProxy->enter(P);
  nodeVisitingProxy->leave(P);
}

}
}
