TEMPLATE = lib 
CONFIG *= staticlib
TARGET = x3dttalgo

HEADERS = X3DProcessor.h \
          X3DOnePassProcessor.h \
          X3DTTAlgorithm.h \
          GlobalVariables.h \
          GVManager.h \
          DFS.h \
          GLDFS.h \
          DefaultDFS.h \
          DFSCoreWalker.h \
          DFSGeometry3DWalker.h \
          DFSGroupingWalker.h \
          DFSRenderingWalker.h \
          DFSShapeWalker.h \
          DFSTexturingWalker.h \
          DefaultDFSCoreWalker.h \
          DefaultDFSGeometry3DWalker.h \
          DefaultDFSGroupingWalker.h \
          DefaultDFSRenderingWalker.h \
          DefaultDFSShapeWalker.h \
          DefaultDFSTexturingWalker.h \
          GLDFSCoreWalker.h \
          GLDFSGeometry3DWalker.h \
          GLDFSGroupingWalker.h \
          GLDFSRenderingWalker.h \
          GLDFSShapeWalker.h \
          GLDFSTexturingWalker.h \
          GLDefaultDFS.h \
          GLDefaultDFSCoreWalker.h \
          GLDefaultDFSGeometry3DWalker.h \
          GLDefaultDFSGroupingWalker.h \
          GLDefaultDFSRenderingWalker.h \
          GLDefaultDFSShapeWalker.h \
          GLDefaultDFSTexturingWalker.h \
          DefaultX3DProcessors/X3DBboxUpdater.h \
          DefaultX3DProcessors/X3DGLBuilder.h  \
          DefaultX3DProcessors/X3DGLRenderer.h  \
          DefaultX3DProcessors/X3DGLUpdater.h  \
          DefaultX3DProcessors/X3DMemReleaser.h  \
          DefaultX3DProcessors/X3DSceneSaver.h \
          DefaultX3DProcessors/X3DFileValidator.h

SOURCES = X3DProcessor.cpp \
          X3DOnePassProcessor.cpp \
          X3DTTAlgorithm.cpp \
          GlobalVariables.cpp \
          GVManager.cpp \
          DFS.cpp \
          GLDFS.cpp \
          DefaultDFS.cpp \
          DFSCoreWalker.cpp \
          DFSGeometry3DWalker.cpp \
          DFSGroupingWalker.cpp \
          DFSRenderingWalker.cpp \
          DFSShapeWalker.cpp \
          DFSTexturingWalker.cpp \
          DefaultDFSCoreWalker.cpp \
          DefaultDFSGeometry3DWalker.cpp \
          DefaultDFSGroupingWalker.cpp \
          DefaultDFSRenderingWalker.cpp \
          DefaultDFSShapeWalker.cpp \
          DefaultDFSTexturingWalker.cpp \
          GLDFSCoreWalker.cpp \
          GLDFSGeometry3DWalker.cpp \
          GLDFSGroupingWalker.cpp \
          GLDFSRenderingWalker.cpp \
          GLDFSShapeWalker.cpp \
          GLDFSTexturingWalker.cpp \
          GLDefaultDFS.cpp \
          GLDefaultDFSCoreWalker.cpp \
          GLDefaultDFSGeometry3DWalker.cpp \
          GLDefaultDFSGroupingWalker.cpp \
          GLDefaultDFSRenderingWalker.cpp \
          GLDefaultDFSShapeWalker.cpp \
          GLDefaultDFSTexturingWalker.cpp \
          DefaultX3DProcessors/X3DBboxUpdater.cpp \
          DefaultX3DProcessors/X3DGLBuilder.cpp  \
          DefaultX3DProcessors/X3DGLRenderer.cpp  \
          DefaultX3DProcessors/X3DGLUpdater.cpp  \
          DefaultX3DProcessors/X3DMemReleaser.cpp  \
          DefaultX3DProcessors/X3DSceneSaver.cpp \
          DefaultX3DProcessors/X3DFileValidator.cpp          

# --------------------
#  Lighting component
# --------------------

HEADERS += DFSLightingWalker.h \
           DefaultDFSLightingWalker.h

SOURCES += DFSLightingWalker.cpp \
           DefaultDFSLightingWalker.cpp

# -------------------------
#  Interpolation component
# -------------------------

HEADERS += DFSInterpolationWalker.h \
           DefaultDFSInterpolationWalker.h

SOURCES += DFSInterpolationWalker.cpp \
           DefaultDFSInterpolationWalker.cpp

# -----------------
#  NURBS component
# -----------------

HEADERS += DFSNURBSWalker.h \
           DefaultDFSNURBSWalker.h

SOURCES += DFSNURBSWalker.cpp \
           DefaultDFSNURBSWalker.cpp

include(../../X3DToolKit.pri)
