#include "X3DBoundedObject.h"

namespace X3DTK {
namespace X3D {

X3DBoundedObject::X3DBoundedObject()
: X3DObject(), _bboxCenter(SFVec3f(0.0f, 0.0f, 0.0f)), _bboxSize(SFVec3f(-1.0f, -1.0f, -1.0f))
{
}

X3DBoundedObject::X3DBoundedObject(const SFVec3f &bboxCenter, const SFVec3f &bboxSize)
: X3DObject(), _bboxCenter(bboxCenter), _bboxSize(bboxSize)
{
}

X3DBoundedObject::X3DBoundedObject(const X3DBoundedObject &N)
: X3DObject(N), _bboxCenter(N._bboxCenter), _bboxSize(N._bboxSize)
{
}

X3DBoundedObject::~X3DBoundedObject()
{
}

void X3DBoundedObject::setBboxCenter(const SFVec3f &bboxCenter)
{
  _bboxCenter = bboxCenter;
}

void X3DBoundedObject::setBboxSize(const SFVec3f &bboxSize)
{
  _bboxSize = bboxSize;
}

void X3DBoundedObject::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("bboxCenter");
  if (index != -1)
    _bboxCenter = SFVec3f(element->getAttribute(index));

  index = element->getIndexAttribute("bboxSize");
  if (index != -1)
    _bboxSize = SFVec3f(element->getAttribute(index)); 
}

SFString X3DBoundedObject::write() const
{
  SFString attr;
  if (_bboxCenter != SFVec3f(0.0f, 0.0f, 0.0f))
    attr += " bboxCenter=\"" + toSFString(_bboxCenter) + "\"";
  if (_bboxSize != SFVec3f(-1.0f, -1.0f, -1.0f))  
    attr += " bboxSize=\"" + toSFString(_bboxSize) + "\"";
    
  return attr;  
}

}
}
