#include "PositionInterpolator2D.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

PositionInterpolator2D::PositionInterpolator2D()
  : X3DInterpolatorNode(),
    _keyValue(MFVec2f())
{
  defineTypeName("PositionInterpolator2D", "Interpolation");
}

PositionInterpolator2D::PositionInterpolator2D(const MFFloat &key,
                                               const MFVec2f &keyValue)
  : X3DInterpolatorNode(key),
    _keyValue(keyValue)
{
  defineTypeName("PositionInterpolator2D", "Interpolation");
}

PositionInterpolator2D::PositionInterpolator2D(const PositionInterpolator2D &N)
  : X3DInterpolatorNode(N),
    _keyValue(N._keyValue)
{
}

SFNode PositionInterpolator2D::clone() const
{
  return new PositionInterpolator2D(*this);
}

PositionInterpolator2D::~PositionInterpolator2D()
{
}

void PositionInterpolator2D::setKeyValue(const MFVec2f &keyValue)
{
  _keyValue = keyValue;
}

void PositionInterpolator2D::load(const X3DFileElement *element)
{
  X3DInterpolatorNode::load(element);

  int index;
  index = element->getIndexAttribute("keyValue");
  if (index != -1)
    _keyValue = MFVec2f(element->getAttribute(index));
}

SFString PositionInterpolator2D::write() const
{
  SFString attr;
  if (!_keyValue.empty())
    attr += " keyValue=\"" + toSFString(_keyValue) + "\"";

  return X3DInterpolatorNode::write() + attr;  
}

}
}
