/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            Contour2D.h                                     //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef CONTOUR2D
#define CONTOUR2D

#include "X3DGroupingNode.h"
#include "X3DBoundedObject.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/NURBS.html">
/// NURBS component</a> defining a Contour2D
/// (<a href="../../doc/X3DSpecs/Part01/components/NURBS.html#Contour2D">
/// documentation</a>).

class Contour2D : public X3DGroupingNode, public X3DBoundedObject
{
public:
  /// Constructor.
  Contour2D();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~Contour2D();

  /// Adds a child to the Children attribute. Returns TRUE if succeeds.
  virtual bool addChild(const SFAbstractNode &N);
  /// Sets the child. Behaves like addChild.
  virtual bool setChild(const SFAbstractNode &N);
  
protected:
  /// Copy constructor.  
  Contour2D(const Contour2D &N);
};

}
}

#endif
