#include "Color.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Color::Color()
: X3DColorNode()
{
  defineTypeName("Color", "Rendering");
}

Color::Color(const MFColor &color)
: X3DColorNode(), _color(color)
{
  defineTypeName("Color", "Rendering");
}

Color::Color(const Color &C)
: X3DColorNode(C), _color(C._color)
{
}

SFNode Color::clone() const
{
  return new Color(*this);
}

Color::~Color()
{
}

void Color::setColor(const MFColor &color)
{
  _color = color;
}

void Color::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("color");
  if (index != -1)
    _color = MFColor(element->getAttribute(index));
}

SFString Color::write() const
{
  SFString attr;
  if (!_color.empty())
    attr += " color=\"" + toSFString(_color) + "\"";
      
  return attr;
}

}
}
