#include "Shape.h"

namespace X3DTK {
namespace X3D {

Shape::Shape()
: X3DShapeNode(), X3DBoundedObject()
{ 
  defineTypeName("Shape", "Shape");
}

Shape::Shape(const X3DGeometryNode *geometry,  const X3DAppearanceNode *appearance,  const SFVec3f &bboxCenter,  const SFVec3f &bboxSize)
: X3DShapeNode(geometry, appearance), X3DBoundedObject(bboxCenter, bboxSize)
{
  defineTypeName("Shape", "Shape");
}

Shape::Shape(const Shape &S)
: X3DShapeNode(S), X3DBoundedObject(S)
{
}

SFNode Shape::clone() const
{
  return new Shape(*this);
}

Shape::~Shape()
{
}

void Shape::load(const X3DFileElement *element)
{
  X3DBoundedObject::load(element);
}

SFString Shape::write() const
{
  return X3DBoundedObject::write();
}

}
}
