TEMPLATE = lib 
CONFIG *= staticlib
TARGET = x3dnodes

VPATH = Interpolation \
        Lighting \
        NURBS 
        
HEADERS = FileElement/X3DFileElement.h \
          Core/Scene.h \
          Core/X3DNode.h \
	  Core/X3DObject.h \
	  Geometry3D/Cylinder.h \
          Geometry3D/Cone.h \
	  Geometry3D/Sphere.h \
          Geometry3D/Box.h \
          Geometry3D/IndexedFaceSet.h \
	  Grouping/X3DBoundedObject.h \
	  Grouping/X3DChildNode.h \
	  Grouping/X3DGroupingNode.h \
	  Grouping/Group.h \
          Grouping/StaticGroup.h \
	  Grouping/Transform.h \
          Rendering/Color.h \
          Rendering/ColorRGBA.h \
          Rendering/Coordinate.h \
          Rendering/IndexedLineSet.h \
          Rendering/Normal.h \
          Rendering/PointSet.h \
          Rendering/TriangleFanSet.h \
          Rendering/TriangleSet.h \
          Rendering/TriangleStripSet.h \
          Rendering/X3DColorNode.h \
  	  Rendering/X3DComposedGeometryNode.h \
          Rendering/X3DCoordinateNode.h \
          Rendering/X3DGeometricPropertyNode.h \
          Rendering/X3DGeometry3DNode.h \
	  Rendering/X3DGeometryNode.h \
          Rendering/X3DNormalNode.h \
	  Shape/Appearance.h \
	  Shape/FillProperties.h \
	  Shape/LineProperties.h \
	  Shape/Material.h \
	  Shape/Shape.h \
	  Shape/X3DAppearanceChildNode.h \
	  Shape/X3DAppearanceNode.h \
	  Shape/X3DMaterialNode.h \
	  Shape/X3DShapeNode.h \
	  Texturing/X3DTextureNode.h \
          Texturing/X3DTextureCoordinateNode.h \	
	  Texturing/X3DTextureTransformNode.h \
          Texturing/X3DTexture2DNode.h \	
          Texturing/ImageTexture.h \
          Texturing/TextureCoordinate.h \
          
SOURCES = FileElement/X3DFileElement.cpp \
          Core/Scene.cpp \
          Core/X3DNode.cpp \
	  Core/X3DObject.cpp \
	  Geometry3D/Cylinder.cpp \
          Geometry3D/Cone.cpp \
	  Geometry3D/Sphere.cpp \
          Geometry3D/Box.cpp \
          Geometry3D/IndexedFaceSet.cpp \
	  Grouping/X3DBoundedObject.cpp \
	  Grouping/X3DChildNode.cpp \
	  Grouping/X3DGroupingNode.cpp \
	  Grouping/Group.cpp \
          Grouping/StaticGroup.cpp \
	  Grouping/Transform.cpp \
          Rendering/Color.cpp \
          Rendering/ColorRGBA.cpp \
          Rendering/Coordinate.cpp \
          Rendering/IndexedLineSet.cpp \
          Rendering/Normal.cpp \
          Rendering/PointSet.cpp \
          Rendering/TriangleFanSet.cpp \
          Rendering/TriangleSet.cpp \
          Rendering/TriangleStripSet.cpp \
          Rendering/X3DColorNode.cpp \
  	  Rendering/X3DComposedGeometryNode.cpp \
          Rendering/X3DCoordinateNode.cpp \
          Rendering/X3DGeometricPropertyNode.cpp \
          Rendering/X3DGeometry3DNode.cpp \
	  Rendering/X3DGeometryNode.cpp \
          Rendering/X3DNormalNode.cpp \
	  Shape/Appearance.cpp \
	  Shape/FillProperties.cpp \
	  Shape/LineProperties.cpp \
	  Shape/Material.cpp \
	  Shape/Shape.cpp \
	  Shape/X3DAppearanceChildNode.cpp \
	  Shape/X3DAppearanceNode.cpp \
	  Shape/X3DMaterialNode.cpp \
	  Shape/X3DShapeNode.cpp \
	  Texturing/X3DTextureNode.cpp \
          Texturing/X3DTextureCoordinateNode.cpp \	
	  Texturing/X3DTextureTransformNode.cpp \
          Texturing/X3DTexture2DNode.cpp \	
          Texturing/ImageTexture.cpp \
          Texturing/TextureCoordinate.cpp \

# --------------------
#  Lighting component
# --------------------

HEADERS += X3DLightNode.h \
           DirectionalLight.h \
           PointLight.h \
           SpotLight.h

SOURCES += X3DLightNode.cpp \
           DirectionalLight.cpp \
           PointLight.cpp \
           SpotLight.cpp

# -------------------------
#  Interpolation component
# -------------------------

HEADERS += X3DInterpolatorNode.h \
           ColorInterpolator.h \
           CoordinateInterpolator.h \
           CoordinateInterpolator2D.h \
           NormalInterpolator.h \
           OrientationInterpolator.h \
           PositionInterpolator.h \
           PositionInterpolator2D.h \
           ScalarInterpolator.h

SOURCES += X3DInterpolatorNode.cpp \
           ColorInterpolator.cpp \
           CoordinateInterpolator.cpp \
           CoordinateInterpolator2D.cpp \
           NormalInterpolator.cpp \
           OrientationInterpolator.cpp \
           PositionInterpolator.cpp \
           PositionInterpolator2D.cpp \
           ScalarInterpolator.cpp

# -----------------
#  NURBS component
# -----------------

HEADERS += X3DParametricGeometryNode.h \
           Contour2D.h \
           ContourPolyline2D.h \
           #CoordinateDeformer.h \
           NurbsCurve.h \
           NurbsCurve2D.h \
           NurbsGroup.h \
           NurbsPositionInterpolator.h \
           NurbsSurface.h \
           NurbsTextureSurface.h \
           TrimmedSurface.h

SOURCES += X3DParametricGeometryNode.cpp \
           Contour2D.cpp \
           ContourPolyline2D.cpp \
           #CoordinateDeformer.cpp \
           NurbsCurve.cpp \
           NurbsCurve2D.cpp \
           NurbsGroup.cpp \
           NurbsPositionInterpolator.cpp \
           NurbsSurface.cpp \
           NurbsTextureSurface.cpp \
           TrimmedSurface.cpp

include(../../X3DToolKit.pri)
           
contains(DEFINES, XERCES) {           
  HEADERS += FileElement/XercesFileElement.h 
  SOURCES += FileElement/XercesFileElement.cpp 
}
else {
  HEADERS += FileElement/QFileElement.h
  SOURCES += FileElement/QFileElement.cpp 
} 


