#include "BboxUpdaterShapeVisitor.h"
#include "X3DShapeNode.h"
#include "Shape.h"
#include "Bbox.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

BboxUpdaterShapeVisitor::BboxUpdaterShapeVisitor()
: ShapeVisitor()
{
  // WalkOn functions.
  defineNewWalkOnFunction<BboxUpdaterShapeVisitor, X3DShapeNode>(&BboxUpdaterShapeVisitor::walkOnX3DShapeNode);

  // Leave functions.
  defineNewLeaveFunction<BboxUpdaterShapeVisitor, Shape>(&BboxUpdaterShapeVisitor::leaveShape);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<BboxUpdaterGlobalVariables>();
}

BboxUpdaterShapeVisitor::~BboxUpdaterShapeVisitor()
{
}

bool BboxUpdaterShapeVisitor::walkOnX3DShapeNode(X3DShapeNode *N, SFAbstractNode Child) const
{
  return true;
}

void BboxUpdaterShapeVisitor::leaveShape(Shape *S) const
{
  Bbox *BB = globalVariables->getBbox(S);
  if (BB == 0)
  {
    BB = new Bbox(globalVariables->getShapeBbox());
    S->setBboxCenter(BB->getCenter());
    S->setBboxSize(BB->getSize());
    globalVariables->addBbox(S, BB); 
  }
}

}
}
