#include "GLBbox.h"

#include <GL/gl.h>
#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

BboxDrawArray Bbox::bbox_array = BboxDrawArray();

Bbox::Bbox()
: X3DTK::Bbox()
{
}

Bbox::Bbox(const X3DTK::Bbox &BB)
: X3DTK::Bbox(BB)
{
}

Bbox::Bbox(const SFVec3f &min, const SFVec3f &max)
: X3DTK::Bbox(0.5f*(min + max), max - min)
{
}

void Bbox::draw() const
{
  SFVec3f center = getCenter();
  SFVec3f size = getSize();
  
  glPushAttrib(GL_ALL_ATTRIB_BITS);
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_COLOR_MATERIAL);
  glDisable(GL_LIGHTING);
  glColor3f(1.0f, 1.0f, 1.0f);
  glPushMatrix();
  
  glTranslatef(center.x, center.y, center.z);
  glScalef(0.5f*size.x, 0.5f*size.y, 0.5f*size.z); 
  
  glInterleavedArrays(GL_V3F, 0, bbox_array.getBboxVertexArrayAddress());
  glDrawElements(GL_LINES, bbox_array.getBboxSize(), GL_UNSIGNED_INT,  bbox_array.getBboxIndexArrayAddress());

  glPopMatrix();
  glPopAttrib();
}

}
}
