#include "GLRenderer.h"
#include "GLDefaultDFS.h"
#include "GLRendererCoreVisitor.h"
#include "GLRendererGroupingVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

Renderer::Renderer()
: X3DRenderer()
{
  globalVariables = GVManager::getInstanceOf<RendererGlobalVariables>();
  dfs = new DefaultDFS();
  
  dfs->setComponentVisitor(new RendererCoreVisitor());
  dfs->setComponentVisitor(new RendererGroupingVisitor());
}

Renderer::~Renderer()
{
  delete dfs;
}

void Renderer::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
} 

void Renderer::render(X3DNode *N) const
{
  glDisable(GL_COLOR_MATERIAL);
  dfs->traverse(N);
}

}
}
