/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MeshDFS.h                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHDFS_H
#define MESHDFS_H

#include "X3DTTAlgorithm.h"

namespace X3DTK {
namespace Mesh {

class DFSCoreWalker;
class DFSGeometry3DWalker;
class DFSGroupingWalker;
class DFSRenderingWalker;
class DFSShapeWalker;
class DFSTexturingWalker;

/// Class defining the tree traversal algorithm depth first search based on  
/// X3D nodes.

class DFS : public X3DTTAlgorithm
{
public:
  /// Constructor.
  DFS();
  /// Destructor.  
  virtual ~DFS();
  
protected:
  void setComponentWalker(X3DComponentWalker *component);
  
  /// CoreWalker.
  DFSCoreWalker *coreWalker;
  /// CoreWalker.
  DFSGeometry3DWalker *geometry3DWalker;
  /// Geometry3DWalker.
  DFSGroupingWalker *groupingWalker;
  /// GroupingWalker.
  DFSRenderingWalker *renderingWalker;
  /// RenderingWalker.
  DFSShapeWalker *shapeWalker;
  /// TexturingWalker.
  DFSTexturingWalker *texturingWalker;        
};

}
}

#endif
